From 82522dbaee8cd5f94267ebf465e36d594e4d2d7a Mon Sep 17 00:00:00 2001
From: Felix Fietkau <nbd@openwrt.org>
Date: Sun, 31 Jan 2016 23:29:07 +0000
Subject: [PATCH] build: introduce SOURCE_DATE_EPOCH variable

SOURCE_DATE_EPOCH is the date of the last modified file using git/svn
as date source.
See https://reproducible-builds.org/specs/source-date-epoch/

Signed-off-by: Alexander Couzens <lynxis@fe80.eu>
Signed-off-by: Felix Fietkau <nbd@openwrt.org>

SVN-Revision: 48584
---
 include/toplevel.mk              |  1 +
 scripts/get_source_date_epoch.sh | 31 +++++++++++++++++++++++++++++++
 2 files changed, 32 insertions(+)
 create mode 100755 scripts/get_source_date_epoch.sh

diff --git a/include/toplevel.mk b/include/toplevel.mk
index 0cba07c6e6..97093021ba 100644
--- a/include/toplevel.mk
+++ b/include/toplevel.mk
@@ -24,6 +24,7 @@ export RELEASE
 export REVISION
 export GIT_CONFIG_PARAMETERS='core.autocrlf=false'
 export MAKE_JOBSERVER=$(filter --jobserver%,$(MAKEFLAGS))
+export SOURCE_DATE_EPOCH:=$(shell $(TOPDIR)/scripts/get_source_date_epoch.sh)
 
 # prevent perforce from messing with the patch utility
 unexport P4PORT P4USER P4CONFIG P4CLIENT
diff --git a/scripts/get_source_date_epoch.sh b/scripts/get_source_date_epoch.sh
new file mode 100755
index 0000000000..b8efb761d0
--- /dev/null
+++ b/scripts/get_source_date_epoch.sh
@@ -0,0 +1,31 @@
+#!/usr/bin/env bash
+export LANG=C
+export LC_ALL=C
+[ -n "$TOPDIR" ] && cd $TOPDIR
+
+try_version() {
+	[ -f version.date ] || return 1
+	SOURCE_DATE_EPOCH="$(cat version.date)"
+	[ -n "$SOURCE_DATE_EPOCH" ]
+}
+
+try_svn() {
+	[ -d .svn ] || return 1
+	SOURCE_DATE_EPOCH="$(./scripts/portable_date.sh "$(svn info --show-item last-changed-date)" +%s)"
+	[ -n "$SOURCE_DATE_EPOCH" ]
+}
+
+try_git() {
+	[ -e .git ] || return 1
+	SOURCE_DATE_EPOCH="$(git log -1 --format=format:%ct)"
+	[ -n "$SOURCE_DATE_EPOCH" ]
+}
+
+try_hg() {
+	[ -d .hg ] || return 1
+	SOURCE_DATE_EPOCH=""
+	[ -n "$SOURCE_DATE_EPOCH" ]
+}
+
+try_version || try_svn || try_git || try_hg || SOURCE_DATE_EPOCH=""
+echo "$SOURCE_DATE_EPOCH"
-- 
GitLab